=== debian/changelog ===
embree (3.8.0+dfsg-1) unstable; urgency=medium

  * New upstream release
  * debian/control: S-V bump 4.4.1 -> 4.5.0 (no changes needed)

 -- Matteo F. Vescovi <mfv@debian.org>  Sun, 09 Feb 2020 14:53:32 +0100

embree (3.7.0+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Matteo F. Vescovi <mfv@debian.org>  Mon, 13 Jan 2020 23:36:51 +0100

embree (3.6.1+dfsg-3) unstable; urgency=medium

  * debian/control: drop python-dev from B-D (Closes: #943004)

 -- Matteo F. Vescovi <mfv@debian.org>  Wed, 08 Jan 2020 15:09:52 +0100

embree (3.6.1+dfsg-2) unstable; urgency=medium

   * debian/rules: parallel builds disabled
   * debian/control:
     - S-V bump 4.4.0 -> 4.4.1
     - RRR set

 -- Matteo F. Vescovi <mfv@debian.org>  Sat, 02 Nov 2019 20:48:23 +0100

embree (3.6.1+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Matteo F. Vescovi <mfv@debian.org>  Sat, 07 Sep 2019 13:36:05 +0200

embree (3.6.0+dfsg-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat
  * Bump Standards-Version to 4.4.0

  [ Matteo F. Vescovi ]
  * New upstream release
  * debian/control: bump debhelper 11 -> 12

 -- Matteo F. Vescovi <mfv@debian.org>  Wed, 28 Aug 2019 23:23:21 +0200

embree (3.5.2+dfsg-2) unstable; urgency=medium

  * Upload to unstable

 -- Matteo F. Vescovi <mfv@debian.org>  Mon, 08 Jul 2019 15:09:17 +0200
